export interface ITheme {
    blue?: string;
    indigo?: string;
    purple?: string;
    pink?: string;
    red?: string;
    orange?: string;
    yellow?: string;
    green?: string;
    teal?: string;
    cyan?: string;
    white?: string;
    gray?: string;
    grayDark?: string;
    primary?: string;
    secondary?: string;
    success?: string;
    info?: string;
    warning?: string;
    danger?: string;
    light?: string;
    dark?: string;
    lightText?: string;
    primaryTextInside?: string;
    secondaryTextInside?: string;
    successTextInside?: string;
    infoTextInside?: string;
    warningTextInside?: string;
    dangerTextInside?: string;
    lightTextInside?: string;
    darkTextInside?: string;
    autocomplete?: {
        barStyle?: string;
        backgroundBarColor?: string;
        backgroundColor?: string;
        backgroundHeaderColor?: string;
        textHeaderColor?: string;
        textIconHeaderColor?: string;
        backgroundInputColorIOS?: string;
    };
    button?: {
        defaultColor?: string;
        textColor?: string;
        outline?: boolean;
        rounded?: boolean;
    };
    checkbox?: {
        defaultColor?: string;
        size?: number;
        rounded?: boolean;
    };
    datePicker?: {
        defaultColor?: string;
    };
    tabs?: {
        textSize?: number;
        backgroundColor?: string;
        backgroundActiveColor?: string;
        textColor?: string;
        textActiveColor?: string;
    };
    PageListing?: {
        tabs?: {
            textSize?: number;
            backgroundColor?: string;
            backgroundActiveColor?: string;
            textColor?: string;
            textActiveColor?: string;
        };
    };
    navigationBar?: {
        backgroundColor?: string;
        textColor?: string;
    };
    navActions?: {
        backgroundColor?: string;
        textColor?: string;
    };
    header?: {
        backgroundColor?: string;
        textColor?: string;
        textColorUsername?: string;
        textColorMenu?: string;
        textColorActiveMenu?: string;
        textColorMenuSub?: string;
    };
}
export declare const ThemeDefault: {
    primary: string;
    secondary: string;
    success: string;
    info: string;
    warning: string;
    danger: string;
    light: string;
    dark: string;
    lightText: string;
    primaryTextInside: string;
    secondaryTextInside: string;
    successTextInside: string;
    infoTextInside: string;
    warningTextInside: string;
    dangerTextInside: string;
    lightTextInside: string;
    darkTextInside: string;
    blue: string;
    indigo: string;
    purple: string;
    pink: string;
    red: string;
    orange: string;
    yellow: string;
    green: string;
    teal: string;
    cyan: string;
    white: string;
    gray: string;
    grayDark: string;
};
//# sourceMappingURL=theme.interface.d.ts.map