import React, { createContext } from 'react';
import { History } from 'history';
import { ICustomInputProps } from '../Input/InputCore.interface';

export interface IAppContext {
   // History para gerenciar
   history?: History<any>;
   // Imagem da página de não encontrado
   imageNotFound?: any;
   // Imagem da página de erro
   imagePageError?: any;
   // Key do youtube
   keyYTB?: string;
   // Components
   customComponents?: {
      Input?: React.FunctionComponent<ICustomInputProps>; // Input Custom
   };
}

export default createContext<IAppContext>({} as IAppContext);
