import React, { ButtonHTMLAttributes } from 'react';

export interface IPropsButton extends ButtonHTMLAttributes<HTMLButtonElement> {
   ref?: React.MutableRefObject<any>;
   onClick?: () => void; // callback ao clicar no botão
   rounded?: boolean; // Se botão deve ter borda arredondada
   outline?: boolean; // Se botão deve ter apenas borda
   bgColor?: string; // Cor de fundo do botão
   w100?: boolean; // width 100%
   type?: 'submit' | 'reset' | 'button'; // Tipo do botão
   size?: 'lg' | 'md' | 'sm'; // Tamanho do botão
   variant?: 'primary' | 'secondary' | 'success' | 'danger' | 'warning' | 'info' | 'dark' | 'light' | 'link'; // Variante de cor
}
