import React from 'react';
import { IPropsBtnClose } from './CloseBtn.interface';
import Style from './CloseBtn.style';

export interface IPropsBtnCloseWeb extends IPropsBtnClose, React.ComponentProps<any> {}

export const CloseBtn: React.FunctionComponent<IPropsBtnCloseWeb> = ({
   size = 24,
   color,
   onClick,
   ...rest
}: IPropsBtnCloseWeb) => {
   return (
      <span data-testid="close-btn" onClick={onClick} className="close-btn" {...rest}>
         <Style color={color} size={size} />
      </span>
   );
};
