import React from 'react';
import { DraggableSyntheticListeners } from '@dnd-kit/core';

export interface IImagesSortableItemProps<T = any> extends React.Component<HTMLDivElement> {
   value: T;
   dragging: boolean;
   dragOverlay: boolean;
   disabled: boolean;
   index: number;
   listeners: DraggableSyntheticListeners;
}

export interface IImagesSortableContainerProps<T = any> {
   id: string;
   index: number;
   useDragOverlay?: boolean;
   value: T;
   renderItem?(args: any): React.ReactElement;
}

export interface IImagesSortableProps {
   images: any[];
   onChange: (images: any[]) => void;
   renderItem: (props: IImagesSortableItemProps) => React.ReactElement;
}
