import React, { useEffect, useReducer, useRef } from 'react';
import { storiesOf } from '@storybook/react';
import { FormHandles } from '@unform/core';
import { Form } from '@unform/web';
import styled from 'styled-components';
import { InputCounter } from './index';

const css = styled.div;

const Style = css`
   background: white !important;
`;

storiesOf('Components/InputCounter', module)
   .add('default', () => {
      return (
         <Style>
            <div className="row">
               <div className="m-4 col-sm-3">
                  <Form onSubmit={() => {}}>
                     <InputCounter name="default" />
                  </Form>
               </div>
            </div>
         </Style>
      );
   })
   .add('with title', () => {
      return (
         <Style>
            <div className="row">
               <div className="m-4 col-sm-3">
                  <Form onSubmit={() => {}}>
                     <InputCounter title="InputCounter" name="default" />
                  </Form>
               </div>
            </div>
         </Style>
      );
   });
