## ScreenMedia (Web)

### Descrição
Componente para visualizar componentes apenas em determinado viewport.

### Uso:

```tsx
import React from 'react';
import { ScreenMedia } from 'react-lib';

const AppComponent = () => {

   return (
      <div>
         <ScreenMedia size={'desktop'}>
            Pode ser visto em telas maiores que 1000px de largura
        </ScreenMedia>

        <ScreenMedia size={'mobile'}>
            Pode ser visto em telas menores ou iguais a 1000px de largura 
        </ScreenMedia>

        <ScreenMedia minWidth={900} maxWidth={1000}>
            Pode ser visto em telas maiores que 900px e menos que 100px de largura
        </ScreenMedia>

        <ScreenMedia minHeight={900} maxHeight={1000}>
            Pode ser visto em telas maiores que 900px e menos que 100px de altura
        </ScreenMedia>
      </div>
   );
};
```

### Opções:

| Nome | Tipo | Descrição |
| --- | --- | --- |
| size (Opcional) | `'desktop'|'mobile'` | Tamanho da tela desktop(min-width: 1000px) ou mobile(max-width: 1000px) |
| maxWidth (Opcional) | `number` | Tamanho máximo da largura |
| minWidth (Opcional) | `number` | Tamanho mímino da largura |
| maxHeight (Opcional) | `number` | Tamanho máximo da altura |
| minHeight (Opcional) | `number` | Tamanho mímino da altura |
   