import styled from 'styled-components';
import { GetThemeVar } from '../../support/GetThemeVar';

const css = styled.div;

export const TagsFiltersStyle = css<any>`
   @keyframes fadeInScale {
      0% {
         transform: scale(0);
      }
      100% {
         transform: scale(1);
      }
   }

   .search-tags {
      .tag {
         background: #fff;
         border-radius: 100px;
         border: 1px solid ${(props) => GetThemeVar(props.theme, 'primary')};
         color: ${(props) => GetThemeVar(props.theme, 'primary')};
         cursor: pointer;
         display: inline-block;
         font-size: 13px;
         height: 28px;
         line-height: 26px;
         position: relative;
         padding: 0 32px 0 12px;
         margin: 2px;
         vertical-align: top;
         opacity: 1;
         animation-name: fadeInScale;
         animation-iteration-count: 1;
         animation-duration: 0.1s;
         user-select: none;
         ${(p) => p.fullColor && `background: ${GetThemeVar(p.theme, 'primary')};`}
         ${(p) => p.fullColor && `color: ${GetThemeVar(p.theme, 'primaryTextInside')};`}

         &:before {
            border-radius: 50%;
            color: ${(props) => GetThemeVar(props.theme, 'primary')};
            ${(p) => p.fullColor && `color: ${GetThemeVar(p.theme, 'primaryTextInside')};`}
            content: '×';
            display: inline-block;
            font-size: 20px;
            height: 14px;
            line-height: 14px;
            padding: 1px;
            position: absolute;
            right: 8px;
            text-align: center;
            top: 5px;
            width: 14px;
            font-weight: 500;
         }
      }
   }

   b {
      font-weight: 600;
   }
`;
