import React from 'react';
import { TextareaHeightChangeMeta } from 'react-textarea-autosize/dist/declarations/src';

export interface IPropsTextareaProps extends Omit<React.HTMLProps<HTMLTextAreaElement>, 'as' | 'onInput'> {
   name?: any; // name do input (Se name for definido Unnform será ativado)
   title?: any; // titulo do campo
   error?: string; // string de erro
   value?: string; // value do input caso use com input state
   onInput?: (text: string) => void; // callback ao digitar no input
   as?: any;
   defaultValue?: string;
   // resize
   placeholder?: string;
   maxRows?: number;
   minRows?: number;
   onHeightChange?: (height: number, meta: TextareaHeightChangeMeta) => void;
   cacheMeasurements?: boolean;
}
