export interface ITheme {
   blue?: string; // #0d6efd
   indigo?: string; // #6610f2
   purple?: string; // #6f42c1
   pink?: string; // #d63384
   red?: string; // #dc3545
   orange?: string; // #fd7e14
   yellow?: string; // #ffc107
   green?: string; // #6c757d
   teal?: string; // #20c997
   cyan?: string; // #0dcaf0
   white?: string; // #fff
   gray?: string; // #0d6efd
   grayDark?: string; // #343a40
   primary?: string; // #0d6efd
   secondary?: string; // #0d6efd
   success?: string; // #6c757d
   info?: string; // #0dcaf0
   warning?: string; // #ffc107
   danger?: string; // #dc3545
   light?: string; // #f8f9fa
   dark?: string; // #212529
   lightText?: string; // 6666
   primaryTextInside?: string; // white
   secondaryTextInside?: string; // white
   successTextInside?: string; // white
   infoTextInside?: string; // white
   warningTextInside?: string; // white
   dangerTextInside?: string; // white
   lightTextInside?: string; // white
   darkTextInside?: string; // white
   autocomplete?: {
      barStyle?: string; // barStyle (StatusBar)
      backgroundBarColor?: string; // Cor do background (StatusBar)
      backgroundColor?: string; // Cor do fundo da busca
      backgroundHeaderColor?: string; // Cor do fundo header
      textHeaderColor?: string; // Cor do input de busca do header
      textIconHeaderColor?: string; // Cor dos icones do header
      backgroundInputColorIOS?: string; // Cor do input de texto (Apenas para IOS)
   };
   button?: {
      defaultColor?: string; // Se não for definido usa primary
      textColor?: string; // Se não for definido usa primary
      outline?: boolean; // Habilita/Desabilita outline como default para todos os botões
      rounded?: boolean; // Habilita/Desabilita rounded como default para todos os botões
   };
   checkbox?: {
      defaultColor?: string;
      size?: number;
      rounded?: boolean;
   };
   datePicker?: {
      defaultColor?: string;
   };
   tabs?: {
      textSize?: number;
      backgroundColor?: string;
      backgroundActiveColor?: string;
      textColor?: string;
      textActiveColor?: string;
   };
   PageListing?: {
      tabs?: {
         textSize?: number;
         backgroundColor?: string;
         backgroundActiveColor?: string;
         textColor?: string;
         textActiveColor?: string;
      };
   };
   navigationBar?: {
      backgroundColor?: string;
      textColor?: string;
   };
   navActions?: {
      backgroundColor?: string;
      textColor?: string;
   };
   header?: {
      backgroundColor?: string;
      textColor?: string;
      textColorUsername?: string;
      textColorMenu?: string;
      textColorActiveMenu?: string;
      textColorMenuSub?: string;
   };
}

export const ThemeDefault = {
   primary: '#8d02d8',
   secondary: '#1660e9',
   success: '#5cb85c',
   info: '#1380e0',
   warning: '#ff9d06',
   danger: '#fa004c',
   light: '#e3e3e3',
   dark: '#222',
   lightText: '#666',
   primaryTextInside: 'white',
   secondaryTextInside: 'white',
   successTextInside: 'white',
   infoTextInside: 'white',
   warningTextInside: 'white',
   dangerTextInside: 'white',
   lightTextInside: '#222',
   darkTextInside: 'white',
   blue: '#0d6efd',
   indigo: '#6610f2',
   purple: '#6f42c1',
   pink: '#d63384',
   red: '#dc3545',
   orange: '#fd7e14',
   yellow: '#ffc107',
   green: '#6c757d',
   teal: '#20c997',
   cyan: '#0dcaf0',
   white: '#fff',
   gray: '#0d6efd',
   grayDark: '#343a40',
};
